/* Squirrel Script Tool for Simutrans
 * autor Andarix
 *
 * output passenger overcrowded connected halts or all overcrowded halts
 * click on a stop to check connected stops or to click the map for all stops
 */

function init(pl)
{
  return true
}

function work(pl, pos)
{
  local output_message = ""

  local fs_tile = tile_x(pos.x, pos.y, pos.z)
  local line_list = null
  local convoy_list = null

  local wt = null
  if ( fs_tile.has_ways() ) {
    wt = fs_tile.find_object(mo_way).get_waytype()
  }

  local wt_2 = null

  local output_start = translate("Tile") + " " + coord3d_to_string(fs_tile) + "\n"


  if ( fs_tile.get_halt() ) {
    local stations_obj = fs_tile.get_halt()
    line_list = stations_obj.get_line_list()
    convoy_list = stations_obj.get_convoy_list()
    //output_message += line_list.len()

    if ( fs_tile.has_two_ways () ) {
      foreach(thing in fs_tile.get_objects()) {
        if ( thing.get_waytype() != wt ) {
          wt_2 = thing.get_waytype()
          if ( wt == 1 && wt_2 == 2 ) { wt_2 = 7 }
        }
        //... // thing is an instance of the map_object_x (or a derived) class
      }
      //output_message += "\n\n two ways wt_2: " + wt_2
    }

    if ( line_list ) {
      output_message += search_pos(line_list, wt, translate("Line"), fs_tile)
      if ( wt_2 != null ) {
        output_message += search_pos(line_list, wt_2, translate("Line"), fs_tile)
        //output_message += "\n\n test line_list: " + wt_2
      }
      //output_message += "\n\n test line_list: " + wt
    }

    if ( convoy_list ) {
      output_message += search_pos(convoy_list, wt, translate("Convoy"), fs_tile)
      if ( wt_2 != null ) {
        output_message += search_pos(convoy_list, wt_2, translate("Convoy"), fs_tile)
      }
    }

    if ( output_message.len() == 0 ) {
      output_message = "\n\n " + translate("not schedule entry on this tile")
    }

    output_message = output_start + output_message

  } else {

    output_message = translate("tile is not a halt tile")

  }

  return gui.add_message_at(pl, output_message, world.get_time())
}

function exit(pl)
{
  return true
}

function search_pos(obj, wt, ty, fs_tile) {
  local output = ""

      foreach(cnv in obj) {

        if ( cnv.get_waytype() == wt ) {
          local sched_entry = cnv.get_schedule().entries
          local entry_count = sched_entry.len()
          for ( local i = 0; i < entry_count; i++ ) {
            if ( sched_entry[i].x == fs_tile.x && sched_entry[i].y == fs_tile.y && sched_entry[i].z == fs_tile.z ) {
              output += "\n " + ty + ": " + cnv.get_name()
              break
            }
          }

        }
      }

  return output
}
