/* Squirrel Script Tool for Simutrans
 * autor Andarix
 *
 * output mail overcrowded connected halts or all overcrowded halts
 * click on a stop to check connected stops or to click the map for all stops
 */

function init(pl)
{
	return true
}

function work(pl, pos)
{
	local output_message = ""
	local output_message_coord = ""

	local fs_tile = tile_x(pos.x, pos.y, pos.z)
	local stations_list = null
	local count = 0
  local max_message = false
  local max_message_coord = false

	if ( fs_tile.get_halt() ) {
  	local stations_obj = fs_tile.get_halt()
		stations_list = stations_obj.get_connections(good_desc_x("Post"))

    local output_start = format(translate("%s overcrowded connected halts from %s:"), translate("Post"), stations_obj.get_name())

		if ( stations_list.len() > 0 ) {
			local mail_waiting = 0
			foreach(station in stations_list) {

				local list = station.get_connections(good_desc_x("Post"))
				if ( list.len() > 0 ) {
					foreach(target in list) {
						local tile_list = target.get_tile_list()
						mail_waiting += station.get_freight_to_dest(good_desc_x("Post"), tile_list[0])
						mail_waiting += station.get_freight_to_halt(good_desc_x("Post"), target)
					}

				}

				local tile_list = station.get_tile_list()
				if ( station.get_capacity(good_desc_x("Post")) < mail_waiting ) {
					count++

          local message = "\n(" + "[" + mail_waiting + "] " + station.get_name() + " (" + coord_to_string(square_x(tile_list[0].x, tile_list[0].y)) + "))"
          local message_coord = "(" + coord_to_string(square_x(tile_list[0].x, tile_list[0].y)) + ")"
          if ( count > 1 ) { message_coord = ", " + message_coord }

          local t = output_start + " (" + count + ")" + output_message + message
          local t_coord = output_start + " (" + count + ")" + output_message_coord + message_coord

          if ( t.len() < 250 && !max_message ) {
					  output_message += message
            output_message_coord += message_coord
          } else if ( t_coord.len() < 250 ) {
            output_message_coord += message_coord
            max_message = true
          } else if ( !max_message_coord ) {
            output_message = "\n" + output_message_coord + "\n..."
            max_message_coord = true
          }

          if ( max_message && !max_message_coord ) {
            output_message = "\n" + output_message_coord
          }

				}
				mail_waiting = 0
			}

			output_message = output_start + " (" + count + ")" + output_message

		} else {
			output_message += format(translate("no %s connected stops"), translate("Post"))
		}

	}	else {

		local mail_waiting = 0
    local output_start = format(translate("%s overcrowded world halts:"), translate("Post"))

    foreach(station in halt_list_x()) {

			if ( station.get_connections(good_desc_x("Post")).len() > 0 ) {
				local list = station.get_connections(good_desc_x("Post"))
				if ( list.len() > 0 ) {
					foreach(target in list) {
						local tile_list = target.get_tile_list()
						mail_waiting += station.get_freight_to_dest(good_desc_x("Post"), tile_list[0])
						mail_waiting += station.get_freight_to_halt(good_desc_x("Post"), target)
					}

				}

				if ( station.get_capacity(good_desc_x("Post")) < mail_waiting ) {
					count++
					local tile_list = station.get_tile_list()

          local message = "\n(" + "[" + mail_waiting + "] " + station.get_name() + " (" + coord_to_string(square_x(tile_list[0].x, tile_list[0].y)) + "))"
          local message_coord = "(" + coord_to_string(square_x(tile_list[0].x, tile_list[0].y)) + ")"
          if ( count > 1 ) { message_coord = ", " + message_coord }

          local t = output_start + " (" + count + ")" + output_message + message
          local t_coord = output_start + " (" + count + ")" + output_message_coord + message_coord

          if ( t.len() < 250 && !max_message ) {
					  output_message += message
            output_message_coord += message_coord
          } else if ( t_coord.len() < 250 ) {
            output_message_coord += message_coord
            max_message = true
          } else if ( !max_message_coord ) {
            output_message = "\n" + output_message_coord + "\n..."
            max_message_coord = true
          }

          if ( max_message && !max_message_coord ) {
            output_message = "\n" + output_message_coord
          }

				}

				mail_waiting = 0
			}
    }

		output_message = output_start + " (" + count + ")" + output_message

	}

	return gui.add_message_at(pl, output_message, world.get_time())
}

function exit(pl)
{
	return true
}